org.firebirdsql.jdbc

## Class FBConnection

- java.lang.Object
- - org.firebirdsql.jdbc.FBConnection

- All Implemented Interfaces:
    java.lang.AutoCloseable, java.sql.Connection, java.sql.Wrapper, FirebirdConnection, Synchronizable

      public class FBConnection
      extends java.lang.Object
      implements FirebirdConnection, Synchronizable

  The class `FBConnection` is a handle to a `FBManagedConnection`.
  Author:
    David Jencks, Mark Rotteveel

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected class` | `FBConnection.GeneratedKeysQuery`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.util.Set<java.sql.Statement>` | `activeStatements`
    `protected FBManagedConnection` | `mc`
    `protected InternalTransactionCoordinator` | `txCoordinator`

    - ### Fields inherited from interface org.firebirdsql.jdbc.FirebirdConnection

      `TPB_CONCURRENCY, TPB_CONSISTENCY, TPB_NO_REC_VERSION, TPB_NOWAIT, TPB_READ, TPB_READ_COMMITTED, TPB_REC_VERSION, TPB_WAIT, TPB_WRITE`

    - ### Fields inherited from interface java.sql.Connection

      `TRANSACTION_NONE, TRANSACTION_READ_COMMITTED, TRANSACTION_READ_UNCOMMITTED, TRANSACTION_REPEATABLE_READ, TRANSACTION_SERIALIZABLE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FBConnection(FBManagedConnection mc)` Create a new AbstractConnection instance based on a `FBManagedConnection`.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `abort(java.util.concurrent.Executor executor)`
    `void` | `addWarning(java.sql.SQLWarning warning)`
    `protected void` | `checkAutoGeneratedKeysSupport()` Helper method to check support of autoGeneratedKeys
    `protected void` | `checkClientInfoSupport()` Checks if client info is supported.
    `protected void` | `checkValidity()` Check if this connection is valid.
    `void` | `clearWarnings()` Clears all warnings reported for this `Connection` object.
    `void` | `close()` Releases a Connection's database and JDBC resources immediately instead of waiting for them to be automatically released.
    `void` | `commit()` Makes all changes made since the previous commit/rollback permanent and releases any database locks currently held by the Connection.
    `java.sql.Array` | `createArrayOf(java.lang.String typeName, java.lang.Object[] elements)`
    `java.sql.Blob` | `createBlob()` Create Blob object.
    `java.sql.Clob` | `createClob()`
    `java.sql.NClob` | `createNClob()`
    `java.sql.SQLXML` | `createSQLXML()`
    `java.sql.Statement` | `createStatement()` Creates a `Statement` object for sending SQL statements to the database.
    `java.sql.Statement` | `createStatement(int resultSetType, int resultSetConcurrency)` Creates a `Statement` object that will generate `ResultSet` objects with the given type and concurrency.
    `java.sql.Statement` | `createStatement(int resultSetType, int resultSetConcurrency, int resultSetHoldability)` Creates a `Statement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability.
    `java.sql.Struct` | `createStruct(java.lang.String typeName, java.lang.Object[] attributes)`
    `TransactionParameterBuffer` | `createTransactionParameterBuffer()` Create new instance of `TransactionParameterBuffer`.
    `protected void` | `finalize()`
    `protected void` | `freeStatements()` This method closes all active statements and cleans resources.
    `boolean` | `getAutoCommit()` Gets the current auto-commit state.
    `java.lang.String` | `getCatalog()` Returns the Connection's current catalog name.
    `java.util.Properties` | `getClientInfo()`
    `protected java.lang.String` | `getClientInfo(java.sql.PreparedStatement stmt, java.lang.String name)`
    `java.lang.String` | `getClientInfo(java.lang.String name)`
    `DatabaseParameterBuffer` | `getDatabaseParameterBuffer()` Get database parameter buffer for this connection.
    `protected FBEscapedParser` | `getEscapedParser()` Returns the FBEscapedParser instance for this connection.
    `FbDatabase` | `getFbDatabase()` Get connection handle for direct Firebird API access
    `GDSHelper` | `getGDSHelper()`
    `int` | `getHoldability()`
    `java.lang.String` | `getIscEncoding()` Get the encoding that is being used for this connection.
    `FirebirdLocalTransaction` | `getLocalTransaction()` Returns a FBLocalTransaction instance that enables a component to demarcate resource manager local transactions on this connection.
    `FBManagedConnection` | `getManagedConnection()`
    `java.sql.DatabaseMetaData` | `getMetaData()` Gets the metadata regarding this connection's database.
    `int` | `getNetworkTimeout()`
    `java.lang.String` | `getSchema()`
    `FBObjectListener.StatementListener` | `getStatementListener()`
    `java.lang.Object` | `getSynchronizationObject()` Get synchronization object.
    `int` | `getTransactionIsolation()` Gets this Connection's current transaction isolation level.
    `TransactionParameterBuffer` | `getTransactionParameters(int isolationLevel)` Get transaction parameters for the specified transaction isolation level.
    `java.util.Map<java.lang.String,java.lang.Class<?>>` | `getTypeMap()` Gets the type map object associated with this connection.
    `java.sql.SQLWarning` | `getWarnings()` Returns the first warning reported by calls on this Connection.
    `boolean` | `inTransaction()` Check if this connection is currently involved in a transaction
    `protected void` | `invalidateSavepoints()` Invalidate all savepoints.
    `protected void` | `invalidateTransactionLifetimeObjects()` Invalidate everything that should only last for the lifetime of the current transaction.
    `boolean` | `isClosed()` Tests to see if a Connection is closed.
    `boolean` | `isReadOnly()` Tests to see if the connection is in read-only mode.
    `boolean` | `isUseFirebirdAutoCommit()`
    `boolean` | `isValid(int timeout)`
    `boolean` | `isWrapperFor(java.lang.Class<?> iface)`
    `java.lang.String` | `nativeSQL(java.lang.String sql)` Converts the given SQL statement into the system's native SQL grammar.
    `java.sql.CallableStatement` | `prepareCall(java.lang.String sql)` Creates a `CallableStatement` object for calling database stored procedures.
    `java.sql.CallableStatement` | `prepareCall(java.lang.String sql, int resultSetType, int resultSetConcurrency)` Creates a `CallableStatement` object that will generate `ResultSet` objects with the given type and concurrency.
    `java.sql.CallableStatement` | `prepareCall(java.lang.String sql, int resultSetType, int resultSetConcurrency, int resultSetHoldability)`
    `protected java.sql.PreparedStatement` | `prepareMetaDataStatement(java.lang.String sql, int resultSetType, int resultSetConcurrency)`
    `java.sql.PreparedStatement` | `prepareStatement(java.lang.String sql)` Creates a `PreparedStatement` object for sending parameterized SQL statements to the database.
    `java.sql.PreparedStatement` | `prepareStatement(java.lang.String sql, int autoGeneratedKeys)` Creates a default `PreparedStatement` object that has the capability to retrieve auto-generated keys.
    `java.sql.PreparedStatement` | `prepareStatement(java.lang.String sql, int[] columnIndexes)` Creates a default `PreparedStatement` object capable of returning the auto-generated keys designated by the given array.
    `java.sql.PreparedStatement` | `prepareStatement(java.lang.String sql, int resultSetType, int resultSetConcurrency)` Creates a `PreparedStatement` object that will generate `ResultSet` objects with the given type and concurrency.
    `java.sql.PreparedStatement` | `prepareStatement(java.lang.String sql, int resultSetType, int resultSetConcurrency, int resultSetHoldability)` Creates a `PreparedStatement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability.
    `protected java.sql.PreparedStatement` | `prepareStatement(java.lang.String sql, int resultSetType, int resultSetConcurrency, int resultSetHoldability, boolean metaData, boolean generatedKeys)`
    `java.sql.PreparedStatement` | `prepareStatement(java.lang.String sql, java.lang.String[] columnNames)` Creates a default `PreparedStatement` object capable of returning the auto-generated keys designated by the given array.
    `void` | `releaseSavepoint(java.sql.Savepoint savepoint)`
    `void` | `rollback()` Drops all changes made since the previous commit/rollback and releases any database locks currently held by this Connection.
    `void` | `rollback(java.sql.Savepoint savepoint)`
    `void` | `setAutoCommit(boolean autoCommit)` Sets this connection's auto-commit mode.
    `void` | `setCatalog(java.lang.String catalog)` Sets a catalog name in order to select a subspace of this Connection's database in which to work.
    `protected void` | `setClientInfo(java.sql.PreparedStatement stmt, java.lang.String name, java.lang.String value)`
    `void` | `setClientInfo(java.util.Properties properties)`
    `void` | `setClientInfo(java.lang.String name, java.lang.String value)`
    `void` | `setHoldability(int holdability)`
    `void` | `setManagedConnection(FBManagedConnection mc)` Set the `FBManagedConnection` around which this connection is based.
    `void` | `setManagedEnvironment(boolean managedConnection)`
    `void` | `setNetworkTimeout(java.util.concurrent.Executor executor, int milliseconds)`
    `void` | `setReadOnly(boolean readOnly)` Puts this connection in read-only mode as a hint to enable database optimizations.
    `java.sql.Savepoint` | `setSavepoint()`
    `java.sql.Savepoint` | `setSavepoint(java.lang.String name)` Creates a named savepoint.
    `void` | `setSchema(java.lang.String schema)`
    `protected void` | `setTransactionCoordinator(boolean managedConnection, boolean autoCommit)`
    `void` | `setTransactionIsolation(int level)` Attempts to change the transaction isolation level to the one given.
    `void` | `setTransactionParameters(int isolationLevel, int[] parameters)` Deprecated.
    `void` | `setTransactionParameters(int isolationLevel, TransactionParameterBuffer tpb)` Set transaction parameters for the specified transaction isolation level.
    `void` | `setTransactionParameters(TransactionParameterBuffer tpb)` Set transaction parameters for the next transactions.
    `void` | `setTypeMap(java.util.Map<java.lang.String,java.lang.Class<?>> map)`
    `<T> T` | `unwrap(java.lang.Class<T> iface)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### mc

          protected FBManagedConnection mc

    - #### txCoordinator

          protected final InternalTransactionCoordinator txCoordinator

    - #### activeStatements

          protected final java.util.Set<java.sql.Statement> activeStatements

  - ### Constructor Detail

    - #### FBConnection

          public FBConnection(FBManagedConnection mc)

      Create a new AbstractConnection instance based on a `FBManagedConnection`.
      Parameters:
        `mc` - A FBManagedConnection around which this connection is based

  - ### Method Detail

    - #### getStatementListener

          public FBObjectListener.StatementListener getStatementListener()

    - #### getHoldability

          public int getHoldability()
                             throws java.sql.SQLException

      Specified by:
        `getHoldability` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException`

    - #### setHoldability

          public void setHoldability(int holdability)
                              throws java.sql.SQLException

      Specified by:
        `setHoldability` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException`

    - #### checkValidity

          protected void checkValidity()
                                throws java.sql.SQLException

      Check if this connection is valid. This method should be invoked before executing any action in this class.
      Throws:
        `java.sql.SQLException` - if this connection has been closed and cannot be used anymore.

    - #### freeStatements

          protected void freeStatements()
                                 throws java.sql.SQLException

      This method closes all active statements and cleans resources.
      Throws:
        `java.sql.SQLException` - if at least one of the active statements failed to close gracefully.

    - #### setManagedConnection

          public void setManagedConnection(FBManagedConnection mc)

      Set the `FBManagedConnection` around which this connection is based.
      Parameters:
        `mc` - The FBManagedConnection around which this connection is based

    - #### getManagedConnection

          public FBManagedConnection getManagedConnection()

    - #### getFbDatabase

          public FbDatabase getFbDatabase()
                                   throws java.sql.SQLException

      Get connection handle for direct Firebird API access
      Specified by:
        `getFbDatabase` in interface `FirebirdConnection`
      Returns:
        internal handle for connection
      Throws:
        `java.sql.SQLException` - if handle needed to be created and creation failed

    - #### getDatabaseParameterBuffer

          public DatabaseParameterBuffer getDatabaseParameterBuffer()

      Get database parameter buffer for this connection.
      Returns:
        instance of `DatabaseParameterBuffer`.

    - #### setTransactionParameters

          @Deprecated
          public void setTransactionParameters(int isolationLevel,
                                                            int[] parameters)
                                                     throws java.sql.SQLException

      Deprecated.
      Description copied from interface: `FirebirdConnection`
      Set transaction parameters for the specified isolation level. They will take effect only on the newly started transaction.
      Specified by:
        `setTransactionParameters` in interface `FirebirdConnection`
      Parameters:
        `isolationLevel` - JDBC isolation level.
        `parameters` - array of TPB parameters, see all TPB_* constants.
      Throws:
        `java.sql.SQLException` - if specified transaction parameters cannot be set.

    - #### getTransactionParameters

          public TransactionParameterBuffer getTransactionParameters(int isolationLevel)
                                                              throws java.sql.SQLException

      Description copied from interface: `FirebirdConnection`
      Get transaction parameters for the specified transaction isolation level.
      Specified by:
        `getTransactionParameters` in interface `FirebirdConnection`
      Parameters:
        `isolationLevel` - isolation level defined in the `Connection` interface.
      Returns:
        instance of `TransactionParameterBuffer` containing current transaction parameters.
      Throws:
        `java.sql.SQLException` - if error occured obtaining transaction parameters.

    - #### createTransactionParameterBuffer

          public TransactionParameterBuffer createTransactionParameterBuffer()
                                                                      throws java.sql.SQLException

      Description copied from interface: `FirebirdConnection`
      Create new instance of `TransactionParameterBuffer`.
      Specified by:
        `createTransactionParameterBuffer` in interface `FirebirdConnection`
      Returns:
        empty instance of `TransactionParameterBuffer`.
      Throws:
        `java.sql.SQLException` - if error occured during this operation.

    - #### setTransactionParameters

          public void setTransactionParameters(int isolationLevel,
                                               TransactionParameterBuffer tpb)
                                        throws java.sql.SQLException

      Description copied from interface: `FirebirdConnection`
      Set transaction parameters for the specified transaction isolation level. This method replaces the default TPB mapping with the specified one, changes will be effective from the next transaction start.
      Specified by:
        `setTransactionParameters` in interface `FirebirdConnection`
      Parameters:
        `isolationLevel` - isolation level defined in the `Connection` interface.
        `tpb` - instance of `TransactionParameterBuffer` with parameters to set.
      Throws:
        `java.sql.SQLException` - if error occured during this operation.

    - #### setTransactionParameters

          public void setTransactionParameters(TransactionParameterBuffer tpb)
                                        throws java.sql.SQLException

      Description copied from interface: `FirebirdConnection`
      Set transaction parameters for the next transactions. This method does not change the TPB mapping, but replaces the mapping for the current transaction isolation until `Connection.setTransactionIsolation(int)` is called.

      Method cannot be called when transaction has already started.

      Specified by:
        `setTransactionParameters` in interface `FirebirdConnection`
      Parameters:
        `tpb` - instance of `TransactionParameterBuffer` with new transaction parameters.
      Throws:
        `java.sql.SQLException` - if method is called within a transaction.

    - #### createStatement

          public java.sql.Statement createStatement()
                                             throws java.sql.SQLException

      Creates a `Statement` object for sending SQL statements to the database. SQL statements without parameters are normally executed using Statement objects. If the same SQL statement is executed many times, it is more efficient to use a `PreparedStatement` object.

      Result sets created using the returned `Statement` object will by default have forward-only type and read-only concurrency.

      Specified by:
        `createStatement` in interface `java.sql.Connection`
      Returns:
        a new Statement object
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### prepareStatement

          public java.sql.PreparedStatement prepareStatement(java.lang.String sql)
                                                      throws java.sql.SQLException

      Creates a `PreparedStatement` object for sending parameterized SQL statements to the database. A SQL statement with or without IN parameters can be pre-compiled and stored in a PreparedStatement object. This object can then be used to efficiently execute this statement multiple times.

      Note: This method is optimized for handling parametric SQL statements that benefit from precompilation. If the driver supports precompilation, the method `prepareStatement` will send the statement to the database for precompilation. Some drivers may not support precompilation. In this case, the statement may not be sent to the database until the `PreparedStatement` is executed. This has no direct effect on users; however, it does affect which method throws certain SQLExceptions. Result sets created using the returned PreparedStatement will have forward-only type and read-only concurrency, by default.

      Specified by:
        `prepareStatement` in interface `java.sql.Connection`
      Parameters:
        `sql` - a SQL statement that may contain one or more '?' IN parameter placeholders
      Returns:
        a new PreparedStatement object containing the pre-compiled statement
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### prepareCall

          public java.sql.CallableStatement prepareCall(java.lang.String sql)
                                                 throws java.sql.SQLException

      Creates a `CallableStatement` object for calling database stored procedures. The `CallableStatement` object provides methods for setting up its IN and OUT parameters, and methods for executing the call to a stored procedure.

      Note: This method is optimized for handling stored procedure call statements. Some drivers may send the call statement to the database when the method `prepareCall` is done; others may wait until the `CallableStatement` object is executed. This has no direct effect on users; however, it does affect which method throws certain SQLExceptions. Result sets created using the returned CallableStatement will have forward-only type and read-only concurrency, by default.

      Specified by:
        `prepareCall` in interface `java.sql.Connection`
      Parameters:
        `sql` - a SQL statement that may contain one or more '?' parameter placeholders. Typically this statement is a JDBC function call escape string.
      Returns:
        a new CallableStatement object containing the pre-compiled SQL statement
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### createBlob

          public java.sql.Blob createBlob()
                                   throws java.sql.SQLException

      Description copied from interface: `FirebirdConnection`
      Create Blob object.
      Specified by:
        `createBlob` in interface `java.sql.Connection`
      Specified by:
        `createBlob` in interface `FirebirdConnection`
      Returns:
        instance of `FirebirdBlob`.
      Throws:
        `java.sql.SQLException` - if something went wrong.

    - #### createClob

          public java.sql.Clob createClob()
                                   throws java.sql.SQLException

      Specified by:
        `createClob` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException`

    - #### createStruct

          public java.sql.Struct createStruct(java.lang.String typeName,
                                              java.lang.Object[] attributes)
                                       throws java.sql.SQLException

      Specified by:
        `createStruct` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException`

    - #### createArrayOf

          public java.sql.Array createArrayOf(java.lang.String typeName,
                                              java.lang.Object[] elements)
                                       throws java.sql.SQLException

      Specified by:
        `createArrayOf` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException`

    - #### nativeSQL

          public java.lang.String nativeSQL(java.lang.String sql)
                                     throws java.sql.SQLException

      Converts the given SQL statement into the system's native SQL grammar. A driver may convert the JDBC sql grammar into its system's native SQL grammar prior to sending it; this method returns the native form of the statement that the driver would have sent.
      Specified by:
        `nativeSQL` in interface `java.sql.Connection`
      Parameters:
        `sql` - a SQL statement that may contain one or more '?' parameter placeholders
      Returns:
        the native form of this statement
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### getEscapedParser

          protected FBEscapedParser getEscapedParser()

      Returns the FBEscapedParser instance for this connection.
      Returns:
        Instance of FBEscapedParser

    - #### setAutoCommit

          public void setAutoCommit(boolean autoCommit)
                             throws java.sql.SQLException

      Sets this connection's auto-commit mode. If a connection is in auto-commit mode, then all its SQL statements will be executed and committed as individual transactions. Otherwise, its SQL statements are grouped into transactions that are terminated by a call to either the method `commit` or the method `rollback`. By default, new connections are in auto-commit mode. The commit occurs when the statement completes or the next execute occurs, whichever comes first. In the case of statements returning a ResultSet, the statement completes when the last row of the ResultSet has been retrieved or the ResultSet has been closed. In advanced cases, a single statement may return multiple results as well as output parameter values. In these cases the commit occurs when all results and output parameter values have been retrieved.
      Specified by:
        `setAutoCommit` in interface `java.sql.Connection`
      Parameters:
        `autoCommit` - true enables auto-commit; false disables auto-commit.
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### setTransactionCoordinator

          protected void setTransactionCoordinator(boolean managedConnection,
                                                   boolean autoCommit)
                                            throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### setManagedEnvironment

          public void setManagedEnvironment(boolean managedConnection)
                                     throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### getAutoCommit

          public boolean getAutoCommit()
                                throws java.sql.SQLException

      Gets the current auto-commit state.
      Specified by:
        `getAutoCommit` in interface `java.sql.Connection`
      Returns:
        the current state of auto-commit mode
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      See Also:
        `setAutoCommit(boolean)`

    - #### commit

          public void commit()
                      throws java.sql.SQLException

      Makes all changes made since the previous commit/rollback permanent and releases any database locks currently held by the Connection. This method should be used only when auto-commit mode has been disabled.
      Specified by:
        `commit` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      See Also:
        `setAutoCommit(boolean)`

    - #### rollback

          public void rollback()
                        throws java.sql.SQLException

      Drops all changes made since the previous commit/rollback and releases any database locks currently held by this Connection. This method should be used only when auto- commit has been disabled.
      Specified by:
        `rollback` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      See Also:
        `setAutoCommit(boolean)`

    - #### invalidateTransactionLifetimeObjects

          protected void invalidateTransactionLifetimeObjects()

      Invalidate everything that should only last for the lifetime of the current transaction.

    - #### close

          public void close()
                     throws java.sql.SQLException

      Releases a Connection's database and JDBC resources immediately instead of waiting for them to be automatically released.

      Note: A Connection is automatically closed when it is garbage collected. Certain fatal errors also result in a closed Connection.

      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### isClosed

          public boolean isClosed()

      Tests to see if a Connection is closed.
      Specified by:
        `isClosed` in interface `java.sql.Connection`
      Returns:
        true if the connection is closed; false if it's still open

    - #### isValid

          public boolean isValid(int timeout)
                          throws java.sql.SQLException

      Specified by:
        `isValid` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException`

    - #### getMetaData

          public java.sql.DatabaseMetaData getMetaData()
                                                throws java.sql.SQLException

      Gets the metadata regarding this connection's database. A Connection's database is able to provide information describing its tables, its supported SQL grammar, its stored procedures, the capabilities of this connection, and so on. This information is made available through a DatabaseMetaData object.
      Specified by:
        `getMetaData` in interface `java.sql.Connection`
      Returns:
        a DatabaseMetaData object for this Connection
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### setReadOnly

          public void setReadOnly(boolean readOnly)
                           throws java.sql.SQLException

      Puts this connection in read-only mode as a hint to enable database optimizations.

      Note: This method cannot be called while in the middle of a transaction.

      Specified by:
        `setReadOnly` in interface `java.sql.Connection`
      Parameters:
        `readOnly` - true enables read-only mode; false disables read-only mode.
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### isReadOnly

          public boolean isReadOnly()
                             throws java.sql.SQLException

      Tests to see if the connection is in read-only mode.
      Specified by:
        `isReadOnly` in interface `java.sql.Connection`
      Returns:
        true if connection is read-only and false otherwise
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### setCatalog

          public void setCatalog(java.lang.String catalog)
                          throws java.sql.SQLException

      Sets a catalog name in order to select a subspace of this Connection's database in which to work. If the driver does not support catalogs, it will silently ignore this request.
      Specified by:
        `setCatalog` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### getCatalog

          public java.lang.String getCatalog()
                                      throws java.sql.SQLException

      Returns the Connection's current catalog name.
      Specified by:
        `getCatalog` in interface `java.sql.Connection`
      Returns:
        the current catalog name or null
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### setTransactionIsolation

          public void setTransactionIsolation(int level)
                                       throws java.sql.SQLException

      Attempts to change the transaction isolation level to the one given. The constants defined in the interface `Connection` are the possible transaction isolation levels.

      Calling this method will commit any current transaction.

      Specified by:
        `setTransactionIsolation` in interface `java.sql.Connection`
      Parameters:
        `level` - one of the TRANSACTION_* isolation values with the exception of TRANSACTION_NONE; some databases may not support other values
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      See Also:
        `DatabaseMetaData.supportsTransactionIsolationLevel(int)`

    - #### getTransactionIsolation

          public int getTransactionIsolation()
                                      throws java.sql.SQLException

      Gets this Connection's current transaction isolation level.
      Specified by:
        `getTransactionIsolation` in interface `java.sql.Connection`
      Returns:
        the current TRANSACTION_* mode value
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### getWarnings

          public java.sql.SQLWarning getWarnings()
                                          throws java.sql.SQLException

      Returns the first warning reported by calls on this Connection.

      Note: Subsequent warnings will be chained to this SQLWarning.

      Specified by:
        `getWarnings` in interface `java.sql.Connection`
      Returns:
        the first SQLWarning or null
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### clearWarnings

          public void clearWarnings()
                             throws java.sql.SQLException

      Clears all warnings reported for this `Connection` object. After a call to this method, the method `getWarnings` returns null until a new warning is reported for this Connection.
      Specified by:
        `clearWarnings` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### createStatement

          public java.sql.Statement createStatement(int resultSetType,
                                                    int resultSetConcurrency)
                                             throws java.sql.SQLException

      Creates a `Statement` object that will generate `ResultSet` objects with the given type and concurrency. This method is the same as the `createStatement` method above, but it allows the default result set type and result set concurrency type to be overridden.
      Specified by:
        `createStatement` in interface `java.sql.Connection`
      Parameters:
        `resultSetType` - a result set type; see ResultSet.TYPE_XXX
        `resultSetConcurrency` - a concurrency type; see ResultSet.CONCUR_XXX
      Returns:
        a new Statement object
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      Since:
        1.2
      See Also:
        What Is in the JDBC 2.0 API

    - #### createStatement

          public java.sql.Statement createStatement(int resultSetType,
                                                    int resultSetConcurrency,
                                                    int resultSetHoldability)
                                             throws java.sql.SQLException

      Creates a `Statement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability. This method is the same as the `createStatement` method above, but it allows the default result set type, concurrency, and holdability to be overridden.
      Specified by:
        `createStatement` in interface `java.sql.Connection`
      Parameters:
        `resultSetType` - one of the following `ResultSet` constants: `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
        `resultSetConcurrency` - one of the following `ResultSet` constants: `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
        `resultSetHoldability` - one of the following `ResultSet` constants: `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
      Returns:
        a new `Statement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability
      Throws:
        `java.sql.SQLException` - if a database access error occurs or the given parameters are not `ResultSet` constants indicating type, concurrency, and holdability
      Since:
        1.4
      See Also:
        `ResultSet`

    - #### prepareStatement

          public java.sql.PreparedStatement prepareStatement(java.lang.String sql,
                                                             int resultSetType,
                                                             int resultSetConcurrency)
                                                      throws java.sql.SQLException

      Creates a `PreparedStatement` object that will generate `ResultSet` objects with the given type and concurrency. This method is the same as the `prepareStatement` method above, but it allows the default result set type and result set concurrency type to be overridden.
      Specified by:
        `prepareStatement` in interface `java.sql.Connection`
      Parameters:
        `resultSetType` - a result set type; see ResultSet.TYPE_XXX
        `resultSetConcurrency` - a concurrency type; see ResultSet.CONCUR_XXX
      Returns:
        a new PreparedStatement object containing the pre-compiled SQL statement
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      Since:
        1.2
      See Also:
        What Is in the JDBC 2.0 API

    - #### prepareStatement

          public java.sql.PreparedStatement prepareStatement(java.lang.String sql,
                                                             int resultSetType,
                                                             int resultSetConcurrency,
                                                             int resultSetHoldability)
                                                      throws java.sql.SQLException

      Creates a `PreparedStatement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability.

      This method is the same as the `prepareStatement` method above, but it allows the default result set type, concurrency, and holdability to be overridden.

      Specified by:
        `prepareStatement` in interface `java.sql.Connection`
      Parameters:
        `sql` - a `String` object that is the SQL statement to be sent to the database; may contain one or more '?' IN parameters
        `resultSetType` - one of the following `ResultSet` constants: `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
        `resultSetConcurrency` - one of the following `ResultSet` constants: `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
        `resultSetHoldability` - one of the following `ResultSet` constants: `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
      Returns:
        a new `PreparedStatement` object, containing the pre-compiled SQL statement, that will generate `ResultSet` objects with the given type, concurrency, and holdability
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed connection or the given parameters are not `ResultSet` constants indicating type, concurrency, and holdability
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method or this method is not supported for the specified result set type, result set holdability and result set concurrency.
      Since:
        1.4
      See Also:
        `ResultSet`

    - #### prepareMetaDataStatement

          protected java.sql.PreparedStatement prepareMetaDataStatement(java.lang.String sql,
                                                                        int resultSetType,
                                                                        int resultSetConcurrency)
                                                                 throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### prepareStatement

          public java.sql.PreparedStatement prepareStatement(java.lang.String sql,
                                                             int autoGeneratedKeys)
                                                      throws java.sql.SQLException

      Creates a default `PreparedStatement` object that has the capability to retrieve auto-generated keys. The given constant tells the driver whether it should make auto-generated keys available for retrieval. This parameter is ignored if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

      Note: This method is optimized for handling parametric SQL statements that benefit from precompilation. If the driver supports precompilation, the method `prepareStatement` will send the statement to the database for precompilation. Some drivers may not support precompilation. In this case, the statement may not be sent to the database until the `PreparedStatement` object is executed. This has no direct effect on users; however, it does affect which methods throw certain SQLExceptions.

      Result sets created using the returned `PreparedStatement` object will by default be type `TYPE_FORWARD_ONLY` and have a concurrency level of `CONCUR_READ_ONLY`. The holdability of the created result sets can be determined by calling `getHoldability()`.

      Specified by:
        `prepareStatement` in interface `java.sql.Connection`
      Parameters:
        `sql` - an SQL statement that may contain one or more '?' IN parameter placeholders
        `autoGeneratedKeys` - a flag indicating whether auto-generated keys should be returned; one of `Statement.RETURN_GENERATED_KEYS` or `Statement.NO_GENERATED_KEYS`
      Returns:
        a new `PreparedStatement` object, containing the pre-compiled SQL statement, that will have the capability of returning auto-generated keys
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed connection or the given parameter is not a `Statement` constant indicating whether auto-generated keys should be returned
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method with a constant of Statement.RETURN_GENERATED_KEYS
      Since:
        1.4

    - #### prepareStatement

          public java.sql.PreparedStatement prepareStatement(java.lang.String sql,
                                                             int[] columnIndexes)
                                                      throws java.sql.SQLException

      Creates a default `PreparedStatement` object capable of returning the auto-generated keys designated by the given array. This array contains the indexes of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

      An SQL statement with or without IN parameters can be pre-compiled and stored in a `PreparedStatement` object. This object can then be used to efficiently execute this statement multiple times.

      Note: This method is optimized for handling parametric SQL statements that benefit from precompilation. If the driver supports precompilation, the method `prepareStatement` will send the statement to the database for precompilation. Some drivers may not support precompilation. In this case, the statement may not be sent to the database until the `PreparedStatement` object is executed. This has no direct effect on users; however, it does affect which methods throw certain SQLExceptions.

      Result sets created using the returned `PreparedStatement` object will by default be type `TYPE_FORWARD_ONLY` and have a concurrency level of `CONCUR_READ_ONLY`. The holdability of the created result sets can be determined by calling `getHoldability()`.

      Specified by:
        `prepareStatement` in interface `java.sql.Connection`
      Parameters:
        `sql` - an SQL statement that may contain one or more '?' IN parameter placeholders
        `columnIndexes` - an array of column indexes indicating the columns that should be returned from the inserted row or rows
      Returns:
        a new `PreparedStatement` object, containing the pre-compiled statement, that is capable of returning the auto-generated keys designated by the given array of column indexes
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed connection
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        1.4

    - #### prepareStatement

          public java.sql.PreparedStatement prepareStatement(java.lang.String sql,
                                                             java.lang.String[] columnNames)
                                                      throws java.sql.SQLException

      Creates a default `PreparedStatement` object capable of returning the auto-generated keys designated by the given array. This array contains the names of the columns in the target table that contain the auto-generated keys that should be returned. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

      An SQL statement with or without IN parameters can be pre-compiled and stored in a `PreparedStatement` object. This object can then be used to efficiently execute this statement multiple times.

      Note: This method is optimized for handling parametric SQL statements that benefit from precompilation. If the driver supports precompilation, the method `prepareStatement` will send the statement to the database for precompilation. Some drivers may not support precompilation. In this case, the statement may not be sent to the database until the `PreparedStatement` object is executed. This has no direct effect on users; however, it does affect which methods throw certain SQLExceptions.

      Result sets created using the returned `PreparedStatement` object will by default be type `TYPE_FORWARD_ONLY` and have a concurrency level of `CONCUR_READ_ONLY`. The holdability of the created result sets can be determined by calling `getHoldability()`.

      Specified by:
        `prepareStatement` in interface `java.sql.Connection`
      Parameters:
        `sql` - an SQL statement that may contain one or more '?' IN parameter placeholders
        `columnNames` - an array of column names indicating the columns that should be returned from the inserted row or rows
      Returns:
        a new `PreparedStatement` object, containing the pre-compiled statement, that is capable of returning the auto-generated keys designated by the given array of column names
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed connection
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        1.4

    - #### checkAutoGeneratedKeysSupport

          protected void checkAutoGeneratedKeysSupport()
                                                throws java.sql.SQLException

      Helper method to check support of autoGeneratedKeys
      Throws:
        `java.sql.SQLException` - If the feature is not supported, or if an error occurred retrieving the server version.

    - #### prepareStatement

          protected java.sql.PreparedStatement prepareStatement(java.lang.String sql,
                                                                int resultSetType,
                                                                int resultSetConcurrency,
                                                                int resultSetHoldability,
                                                                boolean metaData,
                                                                boolean generatedKeys)
                                                         throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### prepareCall

          public java.sql.CallableStatement prepareCall(java.lang.String sql,
                                                        int resultSetType,
                                                        int resultSetConcurrency)
                                                 throws java.sql.SQLException

      Creates a `CallableStatement` object that will generate `ResultSet` objects with the given type and concurrency. This method is the same as the `prepareCall` method above, but it allows the default result set type and result set concurrency type to be overridden.
      Specified by:
        `prepareCall` in interface `java.sql.Connection`
      Parameters:
        `resultSetType` - a result set type; see ResultSet.TYPE_XXX
        `resultSetConcurrency` - a concurrency type; see ResultSet.CONCUR_XXX
      Returns:
        a new CallableStatement object containing the pre-compiled SQL statement
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      Since:
        1.2
      See Also:
        What Is in the JDBC 2.0 API

    - #### prepareCall

          public java.sql.CallableStatement prepareCall(java.lang.String sql,
                                                        int resultSetType,
                                                        int resultSetConcurrency,
                                                        int resultSetHoldability)
                                                 throws java.sql.SQLException

      Specified by:
        `prepareCall` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException`

    - #### getTypeMap

          public java.util.Map<java.lang.String,java.lang.Class<?>> getTypeMap()
                                                                        throws java.sql.SQLException

      Gets the type map object associated with this connection. Unless the application has added an entry to the type map, the map returned will be empty.
      Specified by:
        `getTypeMap` in interface `java.sql.Connection`
      Returns:
        the `java.util.Map` object associated with this `Connection` object
      Throws:
        `java.sql.SQLException`
      Since:
        1.2
      See Also:
        What Is in the JDBC 2.0 API

    - #### setTypeMap

          public void setTypeMap(java.util.Map<java.lang.String,java.lang.Class<?>> map)
                          throws java.sql.SQLException

      Specified by:
        `setTypeMap` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException`

    - #### setSavepoint

          public java.sql.Savepoint setSavepoint()
                                          throws java.sql.SQLException

      Specified by:
        `setSavepoint` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException`

    - #### setSavepoint

          public java.sql.Savepoint setSavepoint(java.lang.String name)
                                          throws java.sql.SQLException

      Creates a named savepoint.

      Savepoint names need to be valid Firebird identifiers, and the maximum length is restricted to the maximum identifier length (see `DatabaseMetaData.getMaxColumnNameLength()`. The implementation will take care of quoting the savepoint name appropriately for the connection dialect. The `name` should be passed unquoted.

      With connection dialect 1, the name is restricted to the rules for unquoted identifier names, that is, its characters are restricted to `A-Za-z0-9$_` and handled case insensitive.

      For dialect 2 and 3, the name is restricted to the rules for Firebird quoted identifiers (essentially any printable character and space is valid), and the name is handled case sensitive.

      Specified by:
        `setSavepoint` in interface `java.sql.Connection`
      Parameters:
        `name` - Savepoint name
      Returns:
        Savepoint object
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called while participating in a distributed transaction, this method is called on a closed connection or this `Connection` object is currently in auto-commit mode

    - #### rollback

          public void rollback(java.sql.Savepoint savepoint)
                        throws java.sql.SQLException

      Specified by:
        `rollback` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException`

    - #### releaseSavepoint

          public void releaseSavepoint(java.sql.Savepoint savepoint)
                                throws java.sql.SQLException

      Specified by:
        `releaseSavepoint` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException`

    - #### invalidateSavepoints

          protected void invalidateSavepoints()

      Invalidate all savepoints.

    - #### getLocalTransaction

          public FirebirdLocalTransaction getLocalTransaction()

      Returns a FBLocalTransaction instance that enables a component to demarcate resource manager local transactions on this connection.

    - #### isWrapperFor

          public boolean isWrapperFor(java.lang.Class<?> iface)
                               throws java.sql.SQLException

      Specified by:
        `isWrapperFor` in interface `java.sql.Wrapper`
      Throws:
        `java.sql.SQLException`

    - #### unwrap

          public <T> T unwrap(java.lang.Class<T> iface)
                       throws java.sql.SQLException

      Specified by:
        `unwrap` in interface `java.sql.Wrapper`
      Throws:
        `java.sql.SQLException`

    - #### setSchema

          public void setSchema(java.lang.String schema)
                         throws java.sql.SQLException

      Specified by:
        `setSchema` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException`

    - #### getSchema

          public java.lang.String getSchema()
                                     throws java.sql.SQLException

      Specified by:
        `getSchema` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException`

    - #### inTransaction

          public boolean inTransaction()
                                throws java.sql.SQLException

      Check if this connection is currently involved in a transaction
      Throws:
        `java.sql.SQLException`

    - #### getIscEncoding

          public java.lang.String getIscEncoding()
                                          throws java.sql.SQLException

      Get the encoding that is being used for this connection.
      Specified by:
        `getIscEncoding` in interface `FirebirdConnection`
      Returns:
        The name of the encoding used
      Throws:
        `java.sql.SQLException`

    - #### addWarning

          public void addWarning(java.sql.SQLWarning warning)

    - #### createNClob

          public java.sql.NClob createNClob()
                                     throws java.sql.SQLException

      Implementation note: This method behaves exactly the same as `createClob()`.

      Specified by:
        `createNClob` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException`

    - #### createSQLXML

          public java.sql.SQLXML createSQLXML()
                                       throws java.sql.SQLException

      Specified by:
        `createSQLXML` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException`

    - #### getGDSHelper

          public GDSHelper getGDSHelper()
                                 throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### isUseFirebirdAutoCommit

          public boolean isUseFirebirdAutoCommit()

      Specified by:
        `isUseFirebirdAutoCommit` in interface `FirebirdConnection`
      Returns:
        `true` if this connection is configured to use `isc_tpb_autocommit` when in auto commit.

    - #### finalize

          protected void finalize()
                           throws java.lang.Throwable

      Overrides:
        `finalize` in class `java.lang.Object`
      Throws:
        `java.lang.Throwable`

    - #### checkClientInfoSupport

          protected void checkClientInfoSupport()
                                         throws java.sql.SQLException

      Checks if client info is supported.
      Throws:
        `java.sql.SQLException` - If the client info is not supported, or if there is no database connection.

    - #### getClientInfo

          public java.util.Properties getClientInfo()
                                             throws java.sql.SQLException

      Specified by:
        `getClientInfo` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException`

    - #### getClientInfo

          public java.lang.String getClientInfo(java.lang.String name)
                                         throws java.sql.SQLException

      Specified by:
        `getClientInfo` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException`

    - #### getClientInfo

          protected java.lang.String getClientInfo(java.sql.PreparedStatement stmt,
                                                   java.lang.String name)
                                            throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### setClientInfo

          public void setClientInfo(java.util.Properties properties)
                             throws java.sql.SQLClientInfoException

      Specified by:
        `setClientInfo` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLClientInfoException`

    - #### setClientInfo

          public void setClientInfo(java.lang.String name,
                                    java.lang.String value)
                             throws java.sql.SQLClientInfoException

      Specified by:
        `setClientInfo` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLClientInfoException`

    - #### setClientInfo

          protected void setClientInfo(java.sql.PreparedStatement stmt,
                                       java.lang.String name,
                                       java.lang.String value)
                                throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### abort

          public void abort(java.util.concurrent.Executor executor)
                     throws java.sql.SQLException

      Specified by:
        `abort` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException`

    - #### setNetworkTimeout

          public void setNetworkTimeout(java.util.concurrent.Executor executor,
                                        int milliseconds)
                                 throws java.sql.SQLException

      Specified by:
        `setNetworkTimeout` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException`

    - #### getNetworkTimeout

          public int getNetworkTimeout()
                                throws java.sql.SQLException

      Specified by:
        `getNetworkTimeout` in interface `java.sql.Connection`
      Throws:
        `java.sql.SQLException`

    - #### getSynchronizationObject

          public final java.lang.Object getSynchronizationObject()

      Description copied from interface: `Synchronizable`
      Get synchronization object.
      Specified by:
        `getSynchronizationObject` in interface `Synchronizable`
      Returns:
        object, cannot be `null`.

Copyright © 2001-2021 Jaybird (Firebird JDBC/JCA) team. All rights reserved.